package net.knarcraft.minecraftserverlauncher.userinterface;

import javax.swing.*;

/**
 * An extended JTabbedPane with dockable tabs
 */
public class JDockableTabbedPane extends JTabbedPane {

    private String tabbedPaneId;

    public JDockableTabbedPane(String tabbedPaneId) {
        super();
        this.tabbedPaneId = tabbedPaneId;
    }

    public JDockableTabbedPane(String tabbedPaneId, int tabPlacement) {
        super(tabPlacement);
        this.tabbedPaneId = tabbedPaneId;
    }

    public JDockableTabbedPane(String tabbedPaneId, int tabPlacement, int tabLayoutPolicy) {
        super(tabPlacement, tabLayoutPolicy);
        this.tabbedPaneId = tabbedPaneId;
    }

    /**
     * Gets the id of this tabbed pane
     * @return <p>The id of this tabbed pane</p>
     */
    public String getTabbedPaneId() {
        return tabbedPaneId;
    }

}
